const char * g_license_backbox_lua_buffer = "function default(value, def)\n"
"	if value == nil then\n"
"		return def\n"
"	else\n"
"		return value\n"
"	end\n"
"end\n"
"\n"
"function format_time_diff(deltat)\n"
"	parts = {\n"
"		{\"day\", math.floor(deltat / (60 * 60 * 24))},\n"
"		{\"hour\", math.floor(deltat / (60 * 60)) % 24},\n"
"		{\"minute\", math.floor(deltat / 60) % 60},\n"
"		{\"second\", math.floor(deltat) % 60}\n"
"	}\n"
"	cur_precision = 0;\n"
"	ret = {}\n"
"	for i,e in ipairs(parts) do\n"
"		k = e[1];\n"
"		v = e[2];\n"
"		if cur_precision > 0 then\n"
"			cur_precision = cur_precision + 1;\n"
"		end\n"
"\n"
"		if v > 0 then\n"
"			if cur_precision == 0 then\n"
"				cur_precision = 1;\n"
"			end\n"
"\n"
"			if cur_precision <= 1 then\n"
"				table.insert(ret, v .. \" \" .. k .. ((v > 1) and \"s\" or \"\"));\n"
"			end\n"
"		end\n"
"	end\n"
"	return table.concat(ret, \" \");\n"
"end\n"
"\n"
"-- For our purposes, a maxed out 32bit int is \"infinity\"\n"
"--  since this doesn't have any immediate drawback (we don't really need\n"
"--  to represent actual infinity) and it makes it easier to interact with other\n"
"--  languages, such as PHP.\n"
"--\n"
"--  XXX: This is susceptible to y2k38 bugs, fix before we need to represent\n"
"--  those dates ...\n"
"INT32_MAX = 2147483647\n"
"DAY_S = 24 * 3600\n"
"-- When redirecting to license page we always \"come\" from a trial license in this file.\n"
"OP5_BLAFFA_URL = \"https://www.op5.com/op5-monitor-license-bounce?lic=trial\"\n"
"OP5_SUPPORT_URL = \"https://www.op5.com/services/support/\"\n"
"\n"
"function query(resp, action, env)\n"
"	systime = env:get(\"system.time\", 0);\n"
"	installation_time = env:get(\"monitor.installation_time\", INT32_MAX)\n"
"	-- No way to limit services in XML licenses, and no limit applies for Trial\n"
"	monitor_services = INT32_MAX\n"
"\n"
"	if backbox.MonitorLicenseType == \"Trial\" then\n"
"		expire_time = installation_time + (30 * DAY_S)\n"
"		num_peers = INT32_MAX\n"
"		num_pollers = INT32_MAX\n"
"		monitor_hosts = INT32_MAX\n"
"		logserver_hosts = INT32_MAX\n"
"	else\n"
"		-- XML license may have an explicit expiry date (but they don't have to\n"
"		-- have one)\n"
"		expire_time = default(backbox.ExpireDate, INT32_MAX)\n"
"		num_peers = default(backbox.peers, 0)\n"
"		num_pollers = default(backbox.pollers, 0)\n"
"		monitor_hosts = default(backbox.MonitorHosts, 0)\n"
"		-- Always allow one \"extra\" logger host (localhost)\n"
"		logserver_hosts = default(backbox.LogserverHosts, 0) + 1\n"
"	end\n"
"\n"
"	resp:add_metric(\"hosts\", env:get(\"monitor.monitoring.hosts\", 0), 0, monitor_hosts)\n"
"	resp:add_metric(\"services\", env:get(\"monitor.monitoring.services\", 0), 0, monitor_services)\n"
"	resp:add_metric(\"peers\", env:get(\"monitor.distribution.peers\", 0), 0, num_peers)\n"
"	resp:add_metric(\"pollers\", env:get(\"monitor.distribution.pollers\", 0), 0, num_pollers)\n"
"	resp:add_metric(\"license_time\", systime, installation_time, expire_time)\n"
"\n"
"	-- The \"blaffa URL\" logic below is only used on trial licenses.\n"
"	-- Old free licenses (v2) are handled as trial licenses.\n"
"	if backbox.MonitorLicenseType == \"Trial\" or backbox.MonitorLicenseType == \"Free\" then\n"
"		if op5lic.subset(action, \"ninja.session:create\") then\n"
"			if systime > expire_time then\n"
"				resp:add_message(\"<<REDIRECT>> \" .. OP5_BLAFFA_URL .. \"&info=expired\");\n"
"				return false\n"
"			end\n"
"			return true\n"
"		end\n"
"		if systime > expire_time then\n"
"			resp:add_message(\"Your license has expired. You need to renew your license.\");\n"
"			resp:add_message(\"Your license expired \" .. format_time_diff(systime - expire_time) .. \" ago\");\n"
"			return false\n"
"		end\n"
"		if op5lic.subset(action, \":read.report.pdf\") then\n"
"			resp:add_message(\"This report was generated using a trial license of op5 Monitor.\");\n"
"			return true\n"
"		end\n"
"		if (systime - installation_time) >= (3 * DAY_S) then\n"
"			resp:add_message(\"<a href='\" .. OP5_SUPPORT_URL ..  \"' target='_blank'>Get access to tips, tutorials, support and more during your trial - click here</a>\");\n"
"			resp:add_message(\"<a href='\" .. OP5_BLAFFA_URL .. \"&info=soontoexpire' target='_blank'>Your license will expire in \" .. format_time_diff(expire_time - systime) .. \"</a>\");\n"
"		end\n"
"\n"
"	end\n"
"\n"
"	if systime + 1 > expire_time then\n"
"		resp:add_message(\"Your license has expired. You need to renew your license.\");\n"
"		return false\n"
"	end\n"
"\n"
"	if op5lic.subset(action, \"monitor.trapper:\") then\n"
"		trapper = default(backbox.trapper, 0)\n"
"		if trapper <= 0 then\n"
"			resp:add_message(\"Your license does not include Trapper\")\n"
"			return false\n"
"		end\n"
"	end\n"
"\n"
"	if env:get(\"monitor.distribution.pollers\",0) > num_pollers then\n"
"		resp:add_message(\"Your usage for pollers is \" .. env:get(\"monitor.distribution.pollers\", 0) .. \", your license allows \" .. num_pollers)\n"
"	end\n"
"\n"
"	if env:get(\"monitor.distribution.peers\", 0) > num_peers then\n"
"		resp:add_message(\"Your usage for peers is \" .. env:get(\"monitor.distribution.peers\", 0) .. \", your license allows \" .. num_peers)\n"
"	end\n"
"\n"
"	if op5lic.subset(action, \":read\") then\n"
"		if backbox.MonitorLicenseType ~= \"Site\" and backbox.MonitorLicenseType ~= \"Trial\" then\n"
"			if env:get(\"monitor.monitoring.hosts\", 0) > monitor_hosts then\n"
"				resp:add_message(\"Your usage for monitor is \" .. env:get(\"monitor.monitoring.hosts\", 0) .. \", your license allows \" .. monitor_hosts)\n"
"			end\n"
"		end\n"
"\n"
"		if backbox.LogserverLicenseType == nil or backbox.LogserverLicenseType ~= \"Site\" then\n"
"			if env:get(\"monitor.logger.hosts\", 0) > logserver_hosts then\n"
"				resp:add_message(\"Your usage for logserver is \" .. env:get(\"monitor.logger.hosts\", 0) .. \", your license allows \" .. logserver_hosts)\n"
"				if op5lic.subset(action, 'monitor.logger:read') then\n"
"					-- Mantis #9777\n"
"					return false\n"
"				end\n"
"			end\n"
"		end\n"
"\n"
"		return true\n"
"	end\n"
"	if op5lic.subset(action, \"monitor:create\") then\n"
"		ret = true\n"
"		if backbox.MonitorLicenseType ~= \"Site\" then\n"
"			if env:get(\"monitor.monitoring.hosts\", 0) > monitor_hosts then\n"
"				resp:add_message(\"Your usage for monitor is \" .. env:get(\"monitor.monitoring.hosts\", 0) .. \", your license allows \" .. monitor_hosts)\n"
"				ret = false\n"
"			end\n"
"		end\n"
"		if backbox.LogserverLicenseType == nil or backbox.LogserverLicenseType ~= \"Site\" then\n"
"			if env:get(\"monitor.logger.hosts\", 0) > logserver_hosts then\n"
"				resp:add_message(\"Your usage for logserver is \" .. env:get(\"monitor.logger.hosts\", 0) .. \", your license allows \" .. logserver_hosts)\n"
"				ret = false\n"
"			end\n"
"		end\n"
"		return ret\n"
"	end\n"
"	return true\n"
"end\n"
;
