#ifndef OP5_LICENSE_METADATA_H
#define OP5_LICENSE_METADATA_H
#include <stdlib.h>
struct op5lic_metadata_t;
struct op5lic_metadata_iter_t {
	/* private, no touchy! */
	size_t *private1;
	void *private2;
	void *private3;
};

enum MetadataFieldType {
	MD_TYPE_TABLE,
	MD_TYPE_STRING
};

struct op5lic_metadata_t *op5lic_metadata_get_table(struct op5lic_metadata_t *, const char *fieldname);
const char * op5lic_metadata_get_str(struct op5lic_metadata_t *, const char *fieldname);
struct op5lic_metadata_t * op5lic_metadata_create(void);
void op5lic_metadata_destroy(struct op5lic_metadata_t *);
void op5lic_metadata_add_field_str(struct op5lic_metadata_t * md,
		const char *fieldname, const char *value);
void op5lic_metadata_add_field_table(struct op5lic_metadata_t * md,
		const char *fieldname, struct op5lic_metadata_t *tbl);

/*Iterator API*/
struct op5lic_metadata_iter_t * op5lic_metadata_iter_next(struct op5lic_metadata_iter_t *iter, char **key, void **value, enum MetadataFieldType *type);
void op5lic_metadata_iter_init(struct op5lic_metadata_iter_t *iter, struct op5lic_metadata_t *md);
#endif
